#Compile Dll "CB.Dll"  'non debug version - uses Jose Roca Includes
#Dim All
#Include "Win32Api.inc"
#Include "ObjBase.inc"
$IID_IClassFactory        =  Guid$("{00000001-0000-0000-C000-000000000046}")
$IID_IUnknown             =  Guid$("{00000000-0000-0000-C000-000000000046}")
$CLSID_CB                 =  Guid$("{20000000-0000-0000-0000-000000000010}")
$IID_IX                   =  Guid$("{20000000-0000-0000-0000-000000000011}")
$IID_IY                   =  Guid$("{20000000-0000-0000-0000-000000000012}")

Type IXVtbl                               'When a variable of this type is instantiated it will occupy
  QueryInterface          As Dword Ptr    '20 bytes.  In this COM Dll there is a global declaration
  AddRef                  As Dword Ptr    'just below as follows: Global IX_Vtbl As IXVtbl.  The same
  Release                 As Dword Ptr    'is done for the IYVtbl.  All the Dword Ptr members of this
  Fx1                     As Dword Ptr    'type (and the IY VTbl) will be initialized in the exported
  Fx2                     As Dword Ptr    'function DllGetClassObjectImpl() when this function is
End Type                                  'called by COM system code that loads the COM Dll.  What...

Type I_X                                  'these members will be initialized with are the addresses of
  lpIX                    As IXVtbl Ptr   'the implementations of the actual interface functions such
End Type                                  'as AddRef() and QueryInterface().  Note that the names of...

Type IYVtbl                               'the implemented functions don't have to match the names of
  QueryInterface          As Dword Ptr    'the Dword Ptr members of these VTables.  In other words, the
  AddRef                  As Dword Ptr    'IXVtbl's QueryInterface pointer member can point to a
  Release                 As Dword Ptr    'function named IX_QueryInterface(), and so forth.  You can
  Fy1                     As Dword Ptr    'see this being done down in DllGetClassObject().  Note that
  Fy2                     As Dword Ptr    'the actual interface variable itself is another type/struct
End Type                                  'that simply contains as its only member a pointer to some...

Type I_Y                                  'virtual function table.  Finally, what we would term a
  lpIY                    As IYVtbl Ptr   'class is created by amalgamating into another type/struct
End Type                                  'a collection of one or more interface pointers plus at...

Type CB                                   'least one long integer member to keep track of how many
  lpIX                    As IXVtbl Ptr   'outstsnding references to the object exists.  The object
  lpIY                    As IYVtbl Ptr   'will be constructed so as to destroy itself when its
  m_cRef  As Long                         'reference count falls to zero.  It is important to
End Type                                  'understand that one of the rules of interface based object...

Type IClassFactoryVtbl                    'oriented programming is that interfaces only contain
  QueryInterface          As Dword Ptr    'functions - no state data.  State data is stored as part
  AddRef                  As Dword Ptr    'of the allocation for an instance of a class as with the
  Release                 As Dword Ptr    'reference counting m_cRef variable above.  The actual
  CreateInstance          As Dword Ptr    'implementations of the procedural functions that constitute
  LockServer              As Dword Ptr    'an object's member functions are passed a pointer to the
End Type                                  'class's 'state' data as the first parameter of the function.

Type IClassFactory1                                 'In the C family of languages this is referred to
  lpVtbl                  As IClassFactoryVtbl Ptr  'as the 'this' pointer and in the Basic family of
End Type                                            'languages as simply 'me'.  Just left you can...


Global g_szFriendlyName   As Asciiz*64              'see the IClassFactoryVtbl and IClassFactory
Global g_szVerIndProgID   As Asciiz*64              'structures being defined.  These structures are
Global g_szProgID         As Asciiz*64              'part of the COM Object creation mechanism. Just 
Global CBClassFactory     As IClassFactory1         'left you can see variable declarations of all of
Global IClassFactory_Vtbl As IClassFactoryVtbl      'these various structures that are required by the
Global IX_Vtbl            As IXVtbl                 'COM standard for component interoperability.  
Global IY_Vtbl            As IYVtbl                 'Most of these globals just left are types/structs
Global g_hModule          As Dword                  'whose pointer members must be initialized.  Again
Global g_lLocks           As Long                   'in this app, that occurs down in DllGetClassObject.
Global g_lObjs            As Long                   'Just below with IX_AddRef() you can see the.....


Function IX_AddRef(ByVal this As I_X Ptr) As Long   'beginning of the implementations of the actual 
  Local hOutput,dwBytesWritten As Dword             'interface functions whose addresses will be set to
  Local szBuffer As Asciiz*64                       'their respective Virtual Function Table members 
  Local pCB As CB Ptr                               'with PowerBASIC's CodePtr() function.  Again, look
  
  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)          'down in DllGetClassObject to see this being done.
  szBuffer="Called IX_AddRef()" & $CrLf             'If you look at the parameter lists of all these
  Call WriteConsole _                               'member function implementations you'll see the 
  ( _                                               'interface pointer is the first or only parameter,
    hOutput, _                                      'as the case may be.  This is so that the function
    szBuffer, _                                     'can get at its state data if necessary.  The 
    Len(szBuffer), _                                'IX_AddRef() and IY_AddRef() functions do need to
    dwBytesWritten, _                               'get at state 'class' data because there is a
    ByVal %NULL _                                   'reference counting variable there - m_cRef, which
  )                                                 'they must increment.  In the special case situation
  pCB=this                                          'of the IX interface, the this pointer passed to
  Incr @pCB.m_cRef                                  'the function is actually serving the dual role of
                            
  IX_AddRef=@pCB.m_cRef                             'also being a pointer to class CB's memory 
End Function                                        'allocation, and therefore no alteration needs to...

Function IY_AddRef(ByVal this As I_Y Ptr) As Long   'be made to its value to reference CB's m_cRef
  Local hOutput,dwBytesWritten As Dword             'member.  See the writeup in the tutorial if you
  Local szBuffer As Asciiz*64                       'don't understand this.  The memory dumps and debug
  Local pCB As CB Ptr                               'outputs there clearly show what is going on with 

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)          'this and its not hard to grasp.  In the case just
  szBuffer="Called IY_AddRef()" & $CrLf             'left though with the IY interface, the this pointer
  Call WriteConsole _                               'that comes into the function can't be used unaltered
  ( _                                               'to access the class's m_cRef member because its four
    hOutput, _                                      'bytes too high.  Perhaps I'd better explain this
    szBuffer, _                                     'here after all.  There is room!  Take a look at the
    Len(szBuffer), _                                'debug output from the CBClient2.bas.  Its the next 
    dwBytesWritten, _                               'last program in the tutorial.  Look at the output
    ByVal %NULL _                                   'for 'Entering CBClassFactory_CreateInstance()'.
  )                                                 'There you can see that when memory for class CB
  Decr this                                         'was requested, the base allocation address received
  pCB=this                                          'was 1336400.  This is simultaneously the value that
  Incr @pCB.m_cRef                                  'comes in through the this pointer when any of the 

  IY_AddRef=@pCB.m_cRef                             'IX interface functions are called, because the 
End Function                                        'first four bytes of this 12 byte allocation.... 


Function IX_Release(ByVal this As I_X Ptr) As Long  'contain the IX Vtable pointer.  That is why for  
  Local hOutput,dwBytesWritten As Dword             'IX_AddRef() all we had to do is set pCB=this and
  Local szBuffer As Asciiz*64                       'access the m_cRef member using Incr @pCB.m_cRef.
  Local pCB As CB Ptr                               'The this pointer that is coming into the IY 

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)          'functions however is 1336404 if using the numbers
  pCB=this                                          'from CBClient2.bas.  If you would use this number
  Decr @pCB.m_cRef                                  'as the CB pointer you would end up incrementing
  If @pCB.m_cRef=0 Then                             'or decrementing as the case may be whatever number
     Call CoTaskMemFree(this)                       'is stored four bytes beyond CB's memory allocation,
     Call InterlockedDecrement(g_lObjs)             'and that wouldn't produce any desirable outcomes!
     szBuffer= _                                    'So all you need to do in any of the IY interface
     "Called IX_Release() And CB Was Deleted!" & _  'functions when it becomes necessary to access
     $CrLf                                          'what I'm referring here to as 'state' data asso-
  Else                                              'ciated with the class CB memory allocation, is
     szBuffer="Called IX_Release()" & $CrLf         'adjust the this pointer the necessary amount so
  End If                                            'as to get you back to CB's base address.  And in
  Call WriteConsole _                               'this Dll we're talking four bytes.  Here in the 
  ( _                                               'IX_Release() and IY_Release() functions you can
    hOutput, _                                      'see how the member m_cRef of class CB is used.
    szBuffer, _                                     'If, after the decrement operation, the value drops
    Len(szBuffer), _                                'to zero, CoTaskMemFree() is called on the CB memory
    dwBytesWritten, _                               'allocation address, and that instance of CB is
    ByVal %NULL _                                   'destroyed.
  )

  Function=@pCB.m_cRef
End Function

Function IY_Release(ByVal this As I_Y Ptr) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*64
  Local pCB As CB Ptr

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  Decr this
  pCB=this
  Decr @pCB.m_cRef
  If @pCB.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Call InterlockedDecrement(g_lObjs)
     szBuffer="Called IY_Release() And CB Was Deleted!" & $CrLf
  Else
     szBuffer="Called IY_Release()" & $CrLf
  End If
  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL)

  Function=@pCB.m_cRef
End Function


Function IX_QueryInterface(ByVal this As I_X Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*64

  @ppv=%NULL                                                                       'Here in the QueryInterface()
  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)                                         'implementations you can see
  Select Case iid                                                                  'the exact same minipulations
    Case $IID_IUnknown                                                             'being done on the address
      szBuffer="Called IX_QueryInterface() For IID_IUnknown" & $CrLf               'passed in through the this
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'pointer as we did above in the
      @ppv=this                                                                    'AddRef() and Release() 
      Call IX_AddRef(this)                                                         'functions.  The only difference
      Function=%S_Ok                                                               'here though is that after the
      Exit Function                                                                'increment or decrement oper-
    Case $IID_IX                                                                   'ation is performed on the this
      szBuffer="Called IX_QueryInterface() For IID_IX" & $CrLf                     'pointer to adjust it to point
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'to the VTable requested in the
      @ppv=this                                                                    'iid parameter, the pointer 
      Call IX_AddRef(this)                                                         'value is stuffed into the
      Function=%S_Ok                                                               'address received in the ppv
      Exit Function                                                                'parameter.  This number would
    Case $IID_IY                                                                   'have come in from the client,
      szBuffer="Called IX_QueryInterface() For IID_IY" & $CrLf                     'and it is how COM returns
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'interface or VTable pointers.
      Incr this
      @ppv=this                                                                    'There are actually some high
      Call IY_AddRef(this)                                                         'powered rules concerning
      Function=%S_Ok                                                               'QueryInterface implementations
      Exit Function                                                                'and these three rules are known
    Case Else                                                                      'as the Symmetric, Reflexive, 
      szBuffer="Called IX_QueryInterface()" & $CrLf                                'and Transitive Rules of Query-
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'Interface.
  End Select

  Function=%E_NoInterface                                                          'According to the Symmetric Rule,
End Function                                                                       'if you query an interface for...


Function IY_QueryInterface(ByVal this As I_Y Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*64

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)                                         '...the interface you already have,
  @ppv=%NULL                                                                       'the call must succeed.  If you 
  Select Case iid                                                                  'check the code for the IX and IY
    Case $IID_IUnknown                                                             'QueryInterface functions you'll
      szBuffer="Called IY_QueryInterface() For IID_IUnknown" & $CrLf               'see that if the same interface
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'pointer is requested as the one
      Decr this                                                                    'that was passed in, the one that
      @ppv=this                                                                    'was passed in is simply returned.
      Call IX_AddRef(this)
      Function=%S_Ok                                                               'According to the Reflexive Rule
      Exit Function                                                                'of QueryInterface(), if you hold
    Case $IID_IX                                                                   'a pointer to one interface on an
      szBuffer="Called IY_QueryInterface() For IID_IX" & $CrLf                     'object and use that to query for
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'another interface, you should be
      Decr this                                                                    'able to use this second pointer
      @ppv=this                                                                    'to successfully navigate back to
      Call IX_AddRef(this)                                                         'your first interface.
      Function=%S_Ok
      Exit Function                                                                'According to the Transitive Rule
    Case $IID_IY                                                                   'of QueryInterface, if you use a
      szBuffer="Called IY_QueryInterface() For IID_IY" & $CrLf                     'first interface to obtain a second
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL) 'interface, and you use that second
      @ppv=this                                                                    'interface to query for a third, 
      Call IY_AddRef(this)                                                         'you should be able to get back to
      Function=%S_Ok                                                               'the first interface from the third.
      Exit Function
    Case Else
      szBuffer="Called IY_QueryInterface()" & $CrLf
      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL)
  End Select

  Function=%S_Ok
End Function


Function Fx1(ByVal this As I_X Ptr, ByVal iNum As Dword) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*32

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  szBuffer="Called Fx1() : iNum = " & Str$(iNum) & $CrLf
  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL)

  Fx1=%S_Ok
End Function

Function Fx2(ByVal this As I_X Ptr, ByVal iNum As Dword) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*32

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  szBuffer="Called Fx2() : iNum = " & Str$(iNum) & $CrLf
  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL)

  Fx2=%S_Ok
End Function

Function Fy1(ByVal this As I_Y Ptr, ByVal iNum As Dword) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*32

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  szBuffer="Called Fy1() : iNum = " & Str$(iNum) & $CrLf
  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL)

  Fy1=%S_Ok
End Function

Function Fy2(ByVal this As I_Y Ptr, ByVal iNum As Dword) As Long
  Local hOutput,dwBytesWritten As Dword
  Local szBuffer As Asciiz*32

  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
  szBuffer="Called Fy1() : iNum = " & Str$(iNum) & $CrLf
  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,ByVal %NULL)

  Fy2=%S_Ok
End Function


Function CBClassFactory_AddRef(ByVal this As IClassFactory1 Ptr) As Long
  Call InterlockedIncrement(g_lObjs)
  CBClassFactory_AddRef=g_lObjs
End Function

Function CBClassFactory_Release(ByVal this As IClassFactory1 Ptr) As Long
  Call InterlockedDecrement(g_lObjs)
  CBClassFactory_Release=g_lObjs
End Function

Function CBClassFactory_QueryInterface(ByVal this As IClassFactory1 Ptr, ByRef RefIID As Guid, ByVal pCF As Dword Ptr) As Long
  @pCF=0                                                      
  If RefIID=$IID_IUnknown Or RefIID=$IID_IClassFactory Then  'If IID_IUnknown or IID_IClassFactory is passed into this
     Call CBClassFactory_AddRef(this)                        'function, all it does is return in the last pointer
     @pCF=this                                               'parameter the address of the IClassFactory1 pointer
     Function=%NOERROR                                       'passed in through the first parameter, i.e., 'this'.
     Exit Function
  End If

  Function=%E_NoInterface
End Function

Function CBClassFactory_CreateInstance(ByVal this As IClassFactory1 Ptr,ByVal pUnknown As Dword, ByRef RefIID As Guid, ByVal ppv As Dword Ptr) As Long
  Local pIX As I_X Ptr
  Local pCB As CB Ptr
  Local hr  As Long

  @ppv=%NULL                                   'CoTaskMemAlloc() is used to allocate 12 bytes for two VTable
  If pUnknown Then                             'pointers and for a reference counting variable m_cRef.  In
     hr=%CLASS_E_NOAGGREGATION                 'the first four bytes of the allocation the starting address
  Else                                         'of the IXVtbl is stored and in the second four bytes (I should
     pCB=CoTaskMemAlloc(SizeOf(CB))            'perhaps preface my remarks with the fact that the four byte 
     If pCB Then                               'business refers to 32 bit operating systems only) the starting 
        @pCB.lpIX=VarPtr(IX_Vtbl)              'address of the IYVtbl is stored.  The last four bytes are
        @pCB.lpIY=VarPtr(IY_Vtbl)              'm_cRef.  Once this memory allocation is successful and these
        @pCB.m_cRef=0                          'initializations are made, IX_QueryInterface is called passing
        pIX=pCB                                'in the RefIID that was passed to this function itself.  If that  
        hr= IX_QueryInterface(pIX,RefIID,ppv)  'RefIID is IID_IUnknown, IID_IX or IID_IY then IX_QueryInterface
        If SUCCEEDED(hr) Then                  'will succeed and the address pointed to by ppv in the
           Call InterlockedIncrement(g_lObjs)  'IX_QueryInterface() call will have a valid interface pointer
           hr=%S_OK                            'stored there.  Note that ppv came in here as the last parameter
        Else                                   'of this function and was passed to IX_QueryInterface.  it
           Call CoTaskMemFree(pCB)             'represents an interface variable allocated in the client and
           hr=%E_NOINTERFACE                   'passed into this COM object.
        End If
     Else
        hr=%E_OutOfMemory
     End If
  End If

  CBClassFactory_CreateInstance=hr
End Function

Function CBClassFactory_LockServer(ByVal this As IClassFactory1 Ptr, ByVal flock As Long) As Long
  If flock Then
     Call InterlockedIncrement(g_lLocks)    'This interface function of IClassFactory is used to lock the server 
  Else                                      'in memory so that the operating system won't unload the binary if no 
     Call InterlockedDecrement(g_lLocks)    'objects creatable within this object presently exist.  You might want 
  End If                                    'to do this if you have a client that periodically destroys all objects, 

  CBClassFactory_LockServer=%NOERROR        'but wants to be able to create others quickly without having to 
End Function                                'reload the dll.


Function DllGetClassObjectImpl Alias "DllGetClassObject" (ByRef RefClsid As Guid, ByRef iid As Guid, ByVal pClassFactory As Dword Ptr) Export As Long
  Local hr As Long

  If RefClsid=$CLSID_CB Or RefClsid=$IID_IClassFactory Then                       'This function is usually called by COM
     IClassFactory_Vtbl.QueryInterface  = CodePtr(CBClassFactory_QueryInterface)  'System code when a client app makes a
     IClassFactory_Vtbl.AddRef          = CodePtr(CBClassFactory_AddRef)          'call to CoCreateInstance() or 
     IClassFactory_Vtbl.Release         = CodePtr(CBClassFactory_Release)         'CoGetClassObject(), which calls require
     IClassFactory_Vtbl.CreateInstance  = CodePtr(CBClassFactory_CreateInstance)  'a class id as a parameter.  This exported
     IClassFactory_Vtbl.LockServer      = CodePtr(CBClassFactory_LockServer)      'function then gets called and all the 
     CBClassFactory.lpVtbl              = VarPtr(IClassFactory_Vtbl)              'various structures required by COM that
     IX_Vtbl.QueryInterface             = CodePtr(IX_QueryInterface)              'we have been discussing in this tutorial 
     IX_Vtbl.AddRef                     = CodePtr(IX_AddRef)                      'get initialized here with the addresses
     IX_Vtbl.Release                    = CodePtr(IX_Release)                     'of the various IClassFactory, IX and IY
     IX_Vtbl.Fx1                        = CodePtr(Fx1)                            'interface functions.  PowerBASIC's CodePtr
     IX_Vtbl.Fx2                        = CodePtr(Fx2)                            'function returns the runtime address of 
     IY_Vtbl.QueryInterface             = CodePtr(IY_QueryInterface)              'procedures in the compiled program's code
     IY_Vtbl.AddRef                     = CodePtr(IY_AddRef)                      'segment.  This function returns through
     IY_Vtbl.Release                    = CodePtr(IY_Release)                     'its last parameter an IClassFactory1
     IY_Vtbl.Fy1                        = CodePtr(Fy1)                            'pointer to the caller if IID_IUnknown
     IY_Vtbl.Fy2                        = CodePtr(Fy2)                            'or IID_IClassFactory was passed in
     hr=CBClassFactory_QueryInterface(VarPtr(CBClassFactory),iid,pClassFactory)   'through the iid parameter.  When the
     If FAILED(hr) Then                                                           'caller receives an IClassFactory pointer
        pClassFactory=0                                                           'the caller can then make a call to
        hr=%CLASS_E_CLASSNOTAVAILABLE                                             'IClassFactory's CreateInstance method
     End If                                                                       'to create an instance of the class.
  End If

  Function=hr
End Function

Function DllCanUnloadNow Alias "DllCanUnloadNow" () Export As Long
  If g_lObjs Or g_lLocks Then
     Function=%FALSE
  Else
     Function=%TRUE
  End If
End Function

Function SetKeyAndValue(ByRef szKey As Asciiz, ByRef szSubKey As Asciiz, ByRef szValue As Asciiz) As Long
  Local szKeyBuf As Asciiz*1024
  Local lResult As Long
  Local hKey As Dword

  If szKey<>"" Then
     szKeyBuf=szKey
     If szSubKey<>"" Then
        szKeyBuf=szKeyBuf+"\"+szSubKey
     End If
     lResult=RegCreateKeyEx(%HKEY_CLASSES_ROOT,szKeyBuf,0,ByVal %NULL,%REG_OPTION_NON_VOLATILE,%KEY_ALL_ACCESS,ByVal %NULL,hKey,%NULL)
     If lResult<>%ERROR_SUCCESS Then
        Function=%FALSE
        Exit Function
     End If
     If szValue<>"" Then
        Call RegSetValueEx(hKey,ByVal %NULL, ByVal 0, %REG_SZ, szValue, Len(szValue)+1)
     End If
     Call RegCloseKey(hKey)
  Else
     Function=%FALSE
     Exit Function
  End If

  Function=%TRUE
End Function

Function RecursiveDeleteKey(ByVal hKeyParent As Dword, ByRef lpszKeyChild As Asciiz) As Long
  Local dwSize,hKeyChild As Dword
  Local szBuffer As Asciiz*256
  Local time As FILETIME
  Local lRes As Long

  dwSize=256
  lRes=RegOpenKeyEx(hKeyParent,lpszKeyChild,0,%KEY_ALL_ACCESS,hKeyChild)
  If lRes<>%ERROR_SUCCESS Then
     Function=lRes
     Exit Function
  End If
  While(RegEnumKeyEx(hKeyChild,0,szBuffer,dwSize,0,ByVal 0,ByVal 0,time)=%S_Ok)
    lRes=RecursiveDeleteKey(hKeyChild,szBuffer)  'Delete the decendents of this child.
    If lRes<>%ERROR_SUCCESS Then
       Call RegCloseKey(hKeyChild)
       Function=lRes
       Exit Function
    End If
    dwSize=256
  Loop
  Call RegCloseKey(hKeyChild)

  Function=RegDeleteKey(hKeyParent,lpszKeyChild)  'Delete this child.
End Function

Function RegisterServer(ByVal hModule As Dword, ByRef Class_id As Guid, ByRef szFriendlyName As Asciiz, ByRef szVerIndProgID As Asciiz, ByRef szProgID As Asciiz) As Long
  Local szModule As Asciiz*512, szClsid As Asciiz*48, szKey As Asciiz*64
  Local iReturn As Long

  If GetModuleFileName(hModule,szModule,512) Then
     szClsid=GuidTxt$(Class_id)
     If szClsid<>"" Then
        szKey="CLSID\"+szClsid
        Call SetKeyAndValue(szKey,ByVal %NULL, szFriendlyName)
        Call SetKeyAndValue(szKey,"InprocServer32",szModule)
        Call SetKeyAndValue(szKey, "ProgID", szProgID)
        Call SetKeyAndValue(szKey,"VersionIndependentProgID",szVerIndProgID)
        Call SetKeyAndValue(szVerIndProgID,ByVal %NULL,"A COM Object Of Class B")
        Call SetKeyAndValue(szVerIndProgID, "CLSID", szClsid)
        Call SetKeyAndValue(szVerIndProgID, "CurVer", szProgID)
        Call SetKeyAndValue(szProgID, ByVal %NULL, "A COM Object Of Class B")
        Call SetKeyAndValue(szProgID, "CLSID", szClsid)
     End If
     Function=%S_Ok
     Exit Function
  Else
     Function=%E_Fail
     Exit Function
  End If
End Function

Function UnregisterServer Alias "UnregisterServer" (ByRef Class_id As Guid, ByRef szVerIndProgID As Asciiz, ByRef szProgID As Asciiz) As Long
  Local szClsid As Asciiz*48, szKey As Asciiz*64
  Local lResult As Long

  szClsid=GuidTxt$(Class_id)
  If szClsid<>"" Then
     szKey="CLSID\"+szClsid
     lResult=RecursiveDeleteKey(%HKEY_CLASSES_ROOT,szKey)
     If lResult<>%ERROR_SUCCESS Then
        Function=%E_Fail
        Exit Function
     End If
     lResult=RecursiveDeleteKey(%HKEY_CLASSES_ROOT, szVerIndProgID)    'Delete the version-independent ProgID Key.
     If lResult<>%ERROR_SUCCESS Then
        Function=%E_Fail
        Exit Function
     End If
     lResult=recursiveDeleteKey(%HKEY_CLASSES_ROOT, szProgID)          'Delete the ProgID key.
     If lResult<>%ERROR_SUCCESS Then
        Function=%E_Fail
        Exit Function
     End If
  Else
     Function=%E_Fail
     Exit Function
  End If

  Function=%S_Ok
End Function

Function DllRegisterServer Alias "DllRegisterServer" () Export As Long
  Function=RegisterServer(g_hModule,$CLSID_CB,g_szFriendlyName,g_szVerIndProgID,g_szProgID)
End Function

Function DllUnregisterServer Alias "DllUnregisterServer" () Export As Long
  Function=UnregisterServer($CLSID_CB,g_szVerIndProgID,g_szProgID)
End Function


Function DllMain(ByVal hInstance As Long, ByVal fwdReason As Long, ByVal lpvReserved As Long) Export As Long
  If fwdReason=%DLL_PROCESS_ATTACH Then
     g_szFriendlyName  =  "A COM Object Of Class B"
     g_szVerIndProgID  =  "ComObject.CB"
     g_szProgID        =  "ComObject.CB.1"
     g_hModule         =  hInstance
     Call DisableThreadLibraryCalls(hInstance)
  End If

  DllMain=%TRUE
End Function

'''Regsvr32 [/u] [/s] <OCX File Name>
'''Regsvr32 c:\code\pwrbasic\pbcc50\cb\cb.dll
'''RegSvr32 /u C:\Code\PwrBasic\PBCC50\CB\CB.dll



''C:\Code\PwrBasic\PBCC50\CB\CB.Dll   'contains piles of debug output statements
'#Compile Dll "CB.Dll"                'use Jose's includes
'#Dim All
'#Include "Win32Api.inc"
'#Include "ObjBase.inc"
'$IID_IClassFactory        =  Guid$("{00000001-0000-0000-C000-000000000046}")
'$IID_IUnknown             =  Guid$("{00000000-0000-0000-C000-000000000046}")
'$CLSID_CB                 =  Guid$("{20000000-0000-0000-0000-000000000010}")
'$IID_IX                   =  Guid$("{20000000-0000-0000-0000-000000000011}")
'$IID_IY                   =  Guid$("{20000000-0000-0000-0000-000000000012}")

'Type IXVtbl
'  QueryInterface          As Dword Ptr
'  AddRef                  As Dword Ptr
'  Release                 As Dword Ptr
'  Fx1                     As Dword Ptr
'  Fx2                     As Dword Ptr
'End Type

'Type I_X
'  lpIX                    As IXVtbl Ptr
'End Type


'Type IYVtbl
'  QueryInterface          As Dword Ptr
'  AddRef                  As Dword Ptr
'  Release                 As Dword Ptr
'  Fy1                     As Dword Ptr
'  Fy2                     As Dword Ptr
'End Type

'Type I_Y
'  lpIY                    As IYVtbl Ptr
'End Type


'Type CB
'  lpIX                    As IXVtbl Ptr
'  lpIY                    As IYVtbl Ptr
'  m_cRef  As Long
'End Type


'Type IClassFactoryVtbl
'  QueryInterface          As Dword Ptr
'  AddRef                  As Dword Ptr
'  Release                 As Dword Ptr
'  CreateInstance          As Dword Ptr
'  LockServer              As Dword Ptr
'End Type

'Type IClassFactory1
'  lpVtbl                  As IClassFactoryVtbl Ptr
'End Type


'Global g_szFriendlyName   As Asciiz*64
'Global g_szVerIndProgID   As Asciiz*64
'Global g_szProgID         As Asciiz*64
'Global CBClassFactory     As IClassFactory1
'Global IClassFactory_Vtbl As IClassFactoryVtbl
'Global IX_Vtbl            As IXVtbl
'Global IY_Vtbl            As IYVtbl
'Global g_hModule          As Dword
'Global g_lLocks           As Long
'Global g_lObjs            As Long

'Function IX_AddRef(ByVal this As I_X Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*64
'  Local pCB As CB Ptr

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Called IX_AddRef()" & $CrLf
'  Call WriteConsole _
'  ( _
'    hOutput, _
'    szBuffer, _
'    Len(szBuffer), _
'    dwBytesWritten, _
'    Byval %NULL _
'  )
'  pCB=this
'  Incr @pCB.m_cRef

'  IX_AddRef=@pCB.m_cRef
'End Function

'Function IY_AddRef(ByVal this As I_Y Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*64
'  Local pCB As CB Ptr

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Called IY_AddRef()" & $CrLf
'  Call WriteConsole _
'  ( _
'    hOutput, _
'    szBuffer, _
'    Len(szBuffer), _
'    dwBytesWritten, _
'    Byval %NULL _
'  )
'  Decr this
'  pCB=this
'  Incr @pCB.m_cRef

'  IY_AddRef=@pCB.m_cRef
'End Function


'Function IX_Release(ByVal this As I_X Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*64
'  Local pCB As CB Ptr

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  pCB=this
'  Decr @pCB.m_cRef
'  If @pCB.m_cRef=0 Then
'     Call CoTaskMemFree(this)
'     Call InterlockedDecrement(g_lObjs)
'     szBuffer="Called IX_Release() And CB Was Deleted!" & $CrLf
'  Else
'     szBuffer="Called IX_Release()" & $CrLf
'  End If
'  Call WriteConsole _
'  ( _
'    hOutput, _
'    szBuffer, _
'    Len(szBuffer), _
'    dwBytesWritten, _
'    Byval %NULL _
'  )

'  Function=@pCB.m_cRef
'End Function

'Function IY_Release(ByVal this As I_Y Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*64
'  Local pCB As CB Ptr

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  Decr this
'  pCB=this
'  Decr @pCB.m_cRef
'  If @pCB.m_cRef=0 Then
'     Call CoTaskMemFree(this)
'     Call InterlockedDecrement(g_lObjs)
'     szBuffer="Called IY_Release() And CB Was Deleted!" & $CrLf
'  Else
'     szBuffer="Called IY_Release()" & $CrLf
'  End If
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  Function=@pCB.m_cRef
'End Function


'Function IX_QueryInterface(ByVal this As I_X Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*64

'  @ppv=%NULL
'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  Select Case iid
'    Case $IID_IUnknown
'      szBuffer="Called IX_QueryInterface() For IID_IUnknown And this=" & Trim$(Str$(this)) & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      @ppv=this
'      Call IX_AddRef(this)
'      Function=%S_OK
'      Exit Function
'    Case $IID_IX
'      szBuffer="Called IX_QueryInterface() For IID_IX And this=" & Trim$(Str$(this)) & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      @ppv=this
'      Call IX_AddRef(this)
'      Function=%S_OK
'      Exit Function
'    Case $IID_IY
'      szBuffer="Called IX_QueryInterface() For IID_IY And this=" & Trim$(Str$(this)) & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      Incr this
'      @ppv=this
'      Call IY_AddRef(this)
'      Function=%S_OK
'      Exit Function
'    Case Else
'      szBuffer="Called IX_QueryInterface()" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  End Select

'  Function=%E_NoInterface
'End Function

'Function IY_QueryInterface(ByVal this As I_Y Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*64

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  @ppv=%NULL
'  Select Case iid
'    Case $IID_IUnknown
'      szBuffer="Called IY_QueryInterface() For IID_IUnknown" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      Decr this
'      @ppv=this
'      Call IX_AddRef(this)
'      Function=%S_OK
'      Exit Function
'    Case $IID_IX
'      szBuffer="Called IY_QueryInterface() For IID_IX" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      Decr this
'      @ppv=this
'      Call IX_AddRef(this)
'      Function=%S_OK
'      Exit Function
'    Case $IID_IY
'      szBuffer="Called IY_QueryInterface() For IID_IY" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      @ppv=this
'      Call IY_AddRef(this)
'      Function=%S_OK
'      Exit Function
'    Case Else
'      szBuffer="Called IY_QueryInterface()" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  End Select

'  Function=%S_Ok
'End Function


'Function Fx1(ByVal this As I_X Ptr, ByVal iNum As Dword) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*32

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Called Fx1() : iNum = " & Str$(iNum) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  Fx1=%S_Ok
'End Function

'Function Fx2(ByVal this As I_X Ptr, ByVal iNum As Dword) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*32

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Called Fx2() : iNum = " & Str$(iNum) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  Fx2=%S_Ok
'End Function

'Function Fy1(ByVal this As I_Y Ptr, ByVal iNum As Dword) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*32

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Called Fy1() : iNum = " & Str$(iNum) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  Fy1=%S_Ok
'End Function

'Function Fy2(ByVal this As I_Y Ptr, ByVal iNum As Dword) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*32

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Called Fy1() : iNum = " & Str$(iNum) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  Fy2=%S_Ok
'End Function


'Function CBClassFactory_AddRef(ByVal this As IClassFactory1 Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Entering CBClassFactory_AddRef()!" + $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  Call InterlockedIncrement(g_lObjs)
'  szBuffer="  g_lObjs = " & Str$(g_lObjs) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="Leaving CBClassFactory_AddRef()!" & $CrLf & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  CBClassFactory_AddRef=g_lObjs
'End Function

'Function CBClassFactory_Release(ByVal this As IClassFactory1 Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Entering CBClassFactory_Release()!" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="  this=" & Str$(this) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  Call InterlockedDecrement(g_lObjs)
'  szBuffer="  g_lObjs = " & Str$(g_lObjs) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="Leaving CBClassFactory_Release()!" & $CrLf & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  CBClassFactory_Release=g_lObjs
'End Function

'Function CBClassFactory_QueryInterface(ByVal this As IClassFactory1 Ptr, ByRef RefIID As Guid, ByVal pCF As Dword Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer = $CrLf & "Entering CBClassFactory_QueryInterface()" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="  this=" & Str$(this) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  If RefIID=$IID_IUnknown Or RefIID=$IID_IClassFactory Then
'     Call CBClassFactory_AddRef(this)
'     @pCF=this
'     szBuffer = "Leaving CBClassFactory_QueryInterface()" & $CrLf & $CrLf
'     Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'     Function=%NOERROR
'     Exit Function
'  End If

'  Function=%E_NoInterface
'End Function

'Function CBClassFactory_CreateInstance(ByVal this As IClassFactory1 Ptr,ByVal pUnknown As Dword, ByRef RefIID As Guid, ByVal ppv As Dword Ptr) As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80
'  Local pIX As I_X Ptr
'  Local pCB As CB Ptr
'  Local hr  As Long

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Entering CBClassFactory_CreateInstance()" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  @ppv=%NULL
'  If pUnknown Then
'     hr=%CLASS_E_NOAGGREGATION
'     Exit Function
'  Else
'     pCB=CoTaskMemAlloc(SizeOf(CB))
'     If pCB Then
'        szBuffer="  pCB="+Trim$(Str$(pCB))+$CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'        @pCB.lpIX=VarPtr(IX_Vtbl)
'        @pCB.lpIY=VarPtr(IY_Vtbl)
'        szBuffer="  @pCB.lpIX="+Trim$(Str$(@pCB.lpIX))+$CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'        szBuffer="  @pCB.lpIY="+Trim$(Str$(@pCB.lpIY))+$CrLf+$CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'        szBuffer=Str$(Varptr(@pCB.lpIX)) + "    " + Str$(@pCB.lpIX) + $CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'        szBuffer=Str$(Varptr(@pCB.lpIY)) + "    " + Str$(@pCB.lpIY) + $CrLf + $CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'        @pCB.m_cRef=0
'        pIX=pCB
'        hr= IX_QueryInterface(pIX,RefIID,ppv)
'        szBuffer=Str$(pIX) + "   " + Str$(@ppv) + $CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'        If SUCCEEDED(hr) Then
'           Call InterlockedIncrement(g_lObjs)
'           hr=%S_OK
'        Else
'           Call CoTaskMemFree(pCB)
'           hr=%E_NOINTERFACE
'        End If
'     Else
'        hr=%E_OutOfMemory
'        Exit Function
'     End If
'  End If
'  szBuffer="  g_lObjs="+Trim$(Str$(g_lObjs))+$CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="Leaving CBClassFactory_CreateInstance()"+$CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  CBClassFactory_CreateInstance=hr
'End Function


'Function CBClassFactory_LockServer(ByVal this As IClassFactory1 Ptr, Byval flock As Long) As Long
'  If flock Then
'     Call InterlockedIncrement(g_lLocks)
'  Else
'     Call InterlockedDecrement(g_lLocks)
'  End If

'  CBClassFactory_LockServer=%NOERROR
'End Function


'Function DllGetClassObjectImpl Alias "DllGetClassObject" (ByRef RefClsid As Guid, ByRef iid As Guid, ByVal pClassFactory As Dword Ptr) Export As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80
'  Local hr As Long

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Entering DllGetClassObject()" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  If RefClsid=$CLSID_CB Or RefClsid=$IID_IClassFactory Then
'     szBuffer= "  Got Inside If So We're Requesting Either CLSID_CB Or IID_IClassFactory!" & $CrLf
'     Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'     IClassFactory_Vtbl.QueryInterface  = CodePtr(CBClassFactory_QueryInterface)
'     IClassFactory_Vtbl.AddRef          = CodePtr(CBClassFactory_AddRef)
'     IClassFactory_Vtbl.Release         = CodePtr(CBClassFactory_Release)
'     IClassFactory_Vtbl.CreateInstance  = CodePtr(CBClassFactory_CreateInstance)
'     IClassFactory_Vtbl.LockServer      = CodePtr(CBClassFactory_LockServer)
'     CBClassFactory.lpVtbl              = VarPtr(IClassFactory_Vtbl)
'     szBuffer="  Varptr(CBClassFactory) = " + Str$(Varptr(CBClassFactory)) + $CrLf
'     Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'     szBuffer="  Varptr(CBClassFactory.lpVtbl=" & Str$(Varptr(CBClassFactory.lpVtbl)) & $CrLf
'     IX_Vtbl.QueryInterface             = CodePtr(IX_QueryInterface)
'     IX_Vtbl.AddRef                     = CodePtr(IX_AddRef)
'     IX_Vtbl.Release                    = CodePtr(IX_Release)
'     IX_Vtbl.Fx1                        = CodePtr(Fx1)
'     IX_Vtbl.Fx2                        = CodePtr(Fx2)
'     IY_Vtbl.QueryInterface             = CodePtr(IY_QueryInterface)
'     IY_Vtbl.AddRef                     = CodePtr(IY_AddRef)
'     IY_Vtbl.Release                    = CodePtr(IY_Release)
'     IY_Vtbl.Fy1                        = CodePtr(Fy1)
'     IY_Vtbl.Fy2                        = CodePtr(Fy2)
'     hr=CBClassFactory_QueryInterface(VarPtr(CBClassFactory),iid,pClassFactory)
'     If FAILED(hr) Then
'        pClassFactory=0
'        hr=%CLASS_E_CLASSNOTAVAILABLE
'     Else
'        szBuffer="  @pClassFactory="+Trim$(Str$(@pClassFactory))+$CrLf
'        Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'     End If
'  End If
'  szBuffer="Leaving DllGetClassObject()" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)

'  Function=hr
'End Function

'Function DllCanUnloadNow Alias "DllCanUnloadNow" () Export As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80
'  Local blnUnload As Long

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  szBuffer="Entering DllCanUnloadNow()" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="  g_lObjs=" & Trim$(Str$(g_lObjs)) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="  g_lLocks=" & Trim$(Str$(g_lLocks)) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  If g_lObjs Or g_lLocks Then
'     Function=%FALSE
'     blnUnload=%FALSE
'  Else
'     Function=%TRUE
'     blnUnload=%TRUE
'  End If
'  szBuffer="  DllCanUnloadNow()=" & Trim$(Str$(blnUnload)) & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  szBuffer="Leaving DllCanUnloadNow()" & $CrLf
'  Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'End Function

'Function SetKeyAndValue(Byref szKey As Asciiz, Byref szSubKey As Asciiz, Byref szValue As Asciiz) As Long
'  Local szKeyBuf As Asciiz*1024
'  Local lResult As Long
'  Local hKey As Dword

'  If szKey<>"" Then
'     szKeyBuf=szKey
'     If szSubKey<>"" Then
'        szKeyBuf=szKeyBuf+"\"+szSubKey
'     End If
'     lResult=RegCreateKeyEx(%HKEY_CLASSES_ROOT,szKeyBuf,0,Byval %NULL,%REG_OPTION_NON_VOLATILE,%KEY_ALL_ACCESS,Byval %NULL,hKey,%NULL)
'     If lResult<>%ERROR_SUCCESS Then
'        Function=%FALSE
'        Exit Function
'     End If
'     If szValue<>"" Then
'        Call RegSetValueEx(hKey,Byval %NULL, Byval 0, %REG_SZ, szValue, Len(szValue)+1)
'     End If
'     Call RegCloseKey(hKey)
'  Else
'     Function=%FALSE
'     Exit Function
'  End If

'  Function=%TRUE
'End Function

'Function RecursiveDeleteKey(Byval hKeyParent As Dword, Byref lpszKeyChild As Asciiz) As Long
'  Local dwSize,hKeyChild As Dword
'  Local szBuffer As Asciiz*256
'  Local time As FILETIME
'  Local lRes As Long

'  dwSize=256
'  lRes=RegOpenKeyEx(hKeyParent,lpszKeyChild,0,%KEY_ALL_ACCESS,hKeyChild)
'  If lRes<>%ERROR_SUCCESS Then
'     Function=lRes
'     Exit Function
'  End If
'  While(RegEnumKeyEx(hKeyChild,0,szBuffer,dwSize,0,Byval 0,Byval 0,time)=%S_OK)
'    lRes=RecursiveDeleteKey(hKeyChild,szBuffer)  'Delete the decendents of this child.
'    If lRes<>%ERROR_SUCCESS Then
'       Call RegCloseKey(hKeyChild)
'       Function=lRes
'       Exit Function
'    End If
'    dwSize=256
'  Loop
'  Call RegCloseKey(hKeyChild)

'  Function=RegDeleteKey(hKeyParent,lpszKeyChild)  'Delete this child.
'End Function

'Function RegisterServer(Byval hModule As Dword, Byref Class_id As Guid, Byref szFriendlyName As Asciiz, Byref szVerIndProgID As Asciiz, Byref szProgID As Asciiz) As Long
'  Local szModule As Asciiz*512, szClsid As Asciiz*48, szKey As Asciiz*64
'  Local iReturn As Long

'  If GetModuleFileName(hModule,szModule,512) Then
'     szClsid=GuidTxt$(Class_id)
'     If szClsid<>"" Then
'        szKey="CLSID\"+szClsid
'        Call SetKeyAndValue(szKey,Byval %NULL, szFriendlyName)
'        Call SetKeyAndValue(szKey,"InprocServer32",szModule)
'        Call SetKeyAndValue(szKey, "ProgID", szProgID)
'        Call SetKeyAndValue(szKey,"VersionIndependentProgID",szVerIndProgID)
'        Call SetKeyAndValue(szVerIndProgID,Byval %NULL,"A COM Object Of Class B")
'        Call SetKeyAndValue(szVerIndProgID, "CLSID", szClsid)
'        Call SetKeyAndValue(szVerIndProgID, "CurVer", szProgID)
'        Call SetKeyAndValue(szProgID, Byval %NULL, "A COM Object Of Class B")
'        Call SetKeyAndValue(szProgID, "CLSID", szClsid)
'     End If
'     Function=%S_OK
'     Exit Function
'  Else
'     Function=%E_FAIL
'     Exit Function
'  End If
'End Function

'Function UnregisterServer Alias "UnregisterServer" (Byref Class_id As Guid, Byref szVerIndProgID As Asciiz, Byref szProgID As Asciiz) As Long
'  Local szClsid As Asciiz*48, szKey As Asciiz*64
'  Local lResult As Long

'  szClsid=GuidTxt$(Class_id)
'  If szClsid<>"" Then
'     szKey="CLSID\"+szClsid
'     lResult=RecursiveDeleteKey(%HKEY_CLASSES_ROOT,szKey)
'     If lResult<>%ERROR_SUCCESS Then
'        Function=%E_FAIL
'        Exit Function
'     End If
'     lResult=RecursiveDeleteKey(%HKEY_CLASSES_ROOT, szVerIndProgID)    'Delete the version-independent ProgID Key.
'     If lResult<>%ERROR_SUCCESS Then
'        Function=%E_FAIL
'        Exit Function
'     End If
'     lResult=recursiveDeleteKey(%HKEY_CLASSES_ROOT, szProgID)          'Delete the ProgID key.
'     If lResult<>%ERROR_SUCCESS Then
'        Function=%E_FAIL
'        Exit Function
'     End If
'  Else
'     Function=%E_FAIL
'     Exit Function
'  End If

'  Function=%S_OK
'End Function

'Function DllRegisterServer Alias "DllRegisterServer" () Export As Long
'  Function=RegisterServer(g_hModule,$CLSID_CB,g_szFriendlyName,g_szVerIndProgID,g_szProgID)
'End Function

'Function DllUnregisterServer Alias "DllUnregisterServer" () Export As Long
'  Function=UnregisterServer($CLSID_CB,g_szVerIndProgID,g_szProgID)
'End Function


'Function DllMain(ByVal hInstance As Long, ByVal fwdReason As Long, ByVal lpvReserved As Long) Export As Long
'  Local hOutput,dwBytesWritten As Dword
'  Local szBuffer As Asciiz*80

'  hOutput=GetStdHandle(%STD_OUTPUT_HANDLE)
'  Select Case As Long fwdReason
'    Case %DLL_PROCESS_ATTACH
'      szBuffer="Received DLL_PROCESS_ATTACH" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'      g_szFriendlyName  =  "A COM Object Of Class B"
'      g_szVerIndProgID  =  "ComObject.CB"
'      g_szProgID        =  "ComObject.CB.1"
'      g_hModule         =  hInstance
'      Call DisableThreadLibraryCalls(hInstance)
'    Case %DLL_PROCESS_DETACH
'      szBuffer="Received DLL_PROCESS_DETACH" & $CrLf
'      Call WriteConsole(hOutput,szBuffer,Len(szBuffer),dwBytesWritten,Byval %NULL)
'  End Select

'  DllMain=%TRUE
'End Function

''Regsvr32 [/u] [/s] <OCX File Name>
''Regsvr32 c:\code\pwrbasic\pbcc50\cb\cb.dll
''RegSvr32 /u C:\Code\PwrBasic\PBCC50\CB\CB.dll  << DESTROYED REGISTRY
